include calc32.inc

.code
start:
	invoke	GetModuleHandle, NULL
	mov	       hInstance, eax
	invoke	DialogBoxParam, hInstance, IDD_MAIN, 0, ADDR DlgProc, 0
	invoke	ExitProcess, eax
; -----------------------------------------------------------------------
DlgProc PROC hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
LOCAL sz1[128]:CHAR
LOCAL sz2[128]:CHAR
        
        mov eax,uMsg
	.if eax == WM_INITDIALOG
		invoke LoadIcon,hInstance,ID_ICON
		invoke SendMessage, hWnd, WM_SETICON, 1, eax
		invoke SetWindowText,hWnd,addr caption
		invoke CheckRadioButton,hWnd,IDC_XOR, IDC_BTS, IDC_XOR
		invoke GetDlgItem,hWnd,IDC_OP2
		mov idc_buffer1,eax
		invoke GetDlgItem,hWnd,IDC_CF
		mov idc_buffer2,eax
		invoke GetDlgItem,hWnd,IDC_REVBYTES
		mov idc_buffer3,eax
		invoke GetDlgItem,hWnd,IDC_SIGNEDINT
		mov idc_buffer4,eax
		invoke EnableWindow,idc_buffer2,FALSE
		
		invoke SendDlgItemMessage,hWnd,IDC_ONTOP,BM_SETCHECK,1,0
		invoke SetWindowPos,hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE+SWP_NOSIZE
		
	.elseif eax == WM_COMMAND
	       mov eax,wParam
	       mov ebx,eax
	       shr ebx,16
		.if ax == BTN_ABOUT
			invoke MessageBox,hWnd,addr AboutTxt,addr caption,MB_ICONINFORMATION
		
		.elseif ax == IDC_ONTOP && bx == BN_CLICKED
		      
		       invoke SendDlgItemMessage,hWnd,IDC_ONTOP,BM_GETCHECK,1,0
		       .if al == BST_CHECKED
		       invoke SetWindowPos,hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE+SWP_NOSIZE
		       .else
		       invoke SetWindowPos,hWnd,HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE+SWP_NOSIZE
		       .endif

		.elseif ( ( ax == IDC_OP1 || ax == IDC_OP2 ) && bx == EN_CHANGE ) || ( ( ax >= IDC_XOR || ax <=IDC_BTS || ax == IDC_CF ) && bx == BN_CLICKED )      
		                
			invoke GetDlgItemText,hWnd,IDC_OP1,addr szOperand1,sizeof szOperand1
			invoke GetDlgItemText,hWnd,IDC_OP2,addr szOperand2,sizeof szOperand2
			
			invoke HexToDw,addr szOperand1
			mov operand1,eax
			invoke HexToDw,addr szOperand2
			mov operand2,eax

			.if WORD ptr wParam == IDC_OP1  &&  WORD ptr wParam+2 == EN_CHANGE
				xor eax,eax
				mov ecx,operand1
				bsr eax,ecx
				.if !ZERO?
					mov sz1[0],0
					mov edx,cat$(ADDR sz1,"BSR: ",str$(eax)," ,")
				.else	
					mov sz1[0],0
					mov edx,cat$(ADDR sz1,"BSR: - ,")
				.endif
				
				xor eax,eax
				mov ecx,operand1
				bsf eax,ecx
				.if !ZERO?
					mov sz2[0],0
					mov edx,cat$(ADDR sz2,"BSF: ",str$(eax))
				.else	
					mov sz2[0],0
					mov edx,cat$(ADDR sz2,"BSF: -")
				.endif
				mov eax,cat$(ADDR sz1,ADDR sz2)
				invoke SetDlgItemText,hWnd,IDSC_OPRT1,ADDR sz1
			.elseif WORD ptr wParam == IDC_OP2  &&  WORD ptr wParam+2 == EN_CHANGE
				xor eax,eax
				mov ecx,operand2
				bsr eax,ecx
				.if !ZERO?
					mov sz1[0],0
					mov edx,cat$(ADDR sz1,"BSR: ",str$(eax)," ,")
				.else	
					mov sz1[0],0
					mov edx,cat$(ADDR sz1,"BSR: - ,")
				.endif
				
				xor eax,eax
				mov ecx,operand2
				bsf eax,ecx
				.if !ZERO?
					mov sz2[0],0
					mov edx,cat$(ADDR sz2,"BSF: ",str$(eax))
				.else	
					mov sz2[0],0
					mov edx,cat$(ADDR sz2,"BSF: -")
				.endif
				mov eax,cat$(ADDR sz1,ADDR sz2)
				invoke SetDlgItemText,hWnd,IDSC_OPRT2,ADDR sz1
			.endif
						
			xor esi,esi
			mov edi,IDC_XOR
		_l1:
			invoke GetDlgItem,hWnd,edi
			invoke SendMessage,eax,BM_GETCHECK,0,0
			or eax,eax
			jnz _esc
			inc edi
			inc esi
			cmp esi,n ; number of operators
		jb _l1
		
		_esc:
			mov operand_idc,edi
			invoke GetDlgItemText,hWnd,edi,addr szStatus, sizeof szStatus
			invoke SetDlgItemText,hWnd,IDC_STATUS,addr szStatus
			
			invoke EnableWindow,idc_buffer1,TRUE
			invoke EnableWindow,idc_buffer2,FALSE
			
		        invoke EnableWindow,idc_buffer3,TRUE
		        invoke EnableWindow,idc_buffer4,TRUE	   
			
			mov eax,operand1
			mov ecx,operand2
			mov edx,operand_idc
			sub edx,IDC_XOR
			jmp [Table+edx*4]
			
		      Table \
		       dd case_01,case_02,case_03,case_04,case_05,case_06,case_07,case_08,case_09,case_10,case_11
		       dd case_12,case_13,case_14,case_15,case_16,case_17,case_18,case_19,case_20,case_21,case_22
		       dd case_23,case_24,case_25,case_26,case_27,case_28,case_29,case_30,case_31,case_32
			
		case_01:
			xor eax,ecx
			jmp _endsw
			
		case_02:
			and eax,ecx
			jmp _endsw
			
		case_03:
			or eax,ecx
			jmp _endsw
			
		case_04:
			test eax,ecx
			jmp _endsw
			
		case_05:
			cmp eax,ecx
			jmp _endsw
			
		case_06:
			invoke EnableWindow,idc_buffer1,FALSE
			mov eax,operand1
			inc eax
			jmp _endsw
			
		case_07:
			invoke EnableWindow,idc_buffer1,FALSE
			mov eax,operand1
			dec eax
			jmp _endsw	
			
		case_08:
			add eax,ecx
			jmp _endsw
			
		case_09:
			invoke EnableWindow,idc_buffer2,TRUE
			invoke SendMessage,idc_buffer2,BM_GETCHECK,0,0
			or eax,eax
			jz _clc1
			stc
			jmp _next1
			_clc1:
			clc
			_next1:
			mov eax,operand1
			mov ecx,operand2
			adc eax,ecx
			jmp _endsw	
			
		case_10:
			sub eax,ecx
			jmp _endsw
			
		case_11:
			invoke EnableWindow,idc_buffer2,TRUE
			invoke SendMessage,idc_buffer2,BM_GETCHECK,0,0
			or eax,eax
			jz _clc2
			stc
			jmp _next2
			_clc2:
			clc
			_next2:
			mov eax,operand1
			mov ecx,operand2
			sbb eax,ecx
			jmp _endsw	
			
		case_12:
			cmp ecx,0FFh
			ja _InputError
			shl eax,cl
			jmp _endsw
			
		case_13:
			cmp ecx,0FFh
			ja _InputError
			shr eax,cl
			jmp _endsw
			
		case_14:
			cmp ecx,0FFh
			ja _InputError
			sal eax,cl
			jmp _endsw
			
		case_15:
			cmp ecx,0FFh
			ja _InputError
			sar eax,cl
			jmp _endsw
			
		case_16:
			cmp ecx,0FFh
			ja _InputError
			rol eax,cl
			jmp _endsw
			
		case_17:
			cmp ecx,0FFh
			ja _InputError
			ror eax,cl
			jmp _endsw
			
		case_18:
			cmp ecx,0FFh
			ja _InputError
			invoke EnableWindow,idc_buffer2,TRUE
			invoke SendMessage,idc_buffer2,BM_GETCHECK,0,0
			or eax,eax
			jz _clc3
			stc
			jmp _next3
			_clc3:
			clc
			_next3:
			mov eax,operand1
			mov ecx,operand2
			rcl eax,cl
			jmp _endsw
			
		case_19:
			cmp ecx,0FFh
			ja _InputError
			invoke EnableWindow,idc_buffer2,TRUE
			invoke SendMessage,idc_buffer2,BM_GETCHECK,0,0
			or eax,eax
			jz _clc4
			stc
			jmp _next4
			_clc4:
			clc
			_next4:
			mov eax,operand1
			mov ecx,operand2
			rcr eax,cl
			jmp _endsw
			
		case_20:
			invoke EnableWindow,idc_buffer1,FALSE
			mov eax,operand1
			bswap eax
			jmp _endsw
			
		case_21:
			invoke EnableWindow,idc_buffer1,FALSE
			mov eax,operand1
			not eax
			jmp _endsw
			
		case_22:
			invoke EnableWindow,idc_buffer1,FALSE
			mov eax,operand1
			neg eax
			jmp _endsw
			
		case_23:
		
			invoke EnableWindow,idc_buffer3,FALSE
			invoke EnableWindow,idc_buffer4,FALSE
			mov eax,operand1
			mov ecx,operand2
			cdq
			mul ecx
			jmp _endsw
			
		case_24:
			invoke EnableWindow,idc_buffer3,FALSE
			invoke EnableWindow,idc_buffer4,FALSE
			mov eax,operand1
			mov ecx,operand2
			cdq
			imul ecx
			jmp _endsw
			
		case_25:
			or ecx,ecx
			jz _InputError
			invoke EnableWindow,idc_buffer3,FALSE
			invoke EnableWindow,idc_buffer4,FALSE
			mov eax,operand1
			mov ecx,operand2
			cdq
			div ecx
			jmp _endsw
			
		case_26:
			or ecx,ecx
			jz _InputError
			invoke EnableWindow,idc_buffer3,FALSE
			invoke EnableWindow,idc_buffer4,FALSE
			mov eax,operand1
			mov ecx,operand2
			cdq
			idiv ecx
			jmp _endsw
			
		case_27:
			bsf eax,ecx
			jmp _endsw
			
		case_28:
			bsr eax,ecx
			jmp _endsw
			
		case_29:
			bt eax,ecx
			jmp _endsw
			
		case_30:
			btc eax,ecx
			jmp _endsw
			
		case_31:
			btr eax,ecx
			jmp _endsw
			
		case_32:
			bts eax,ecx
			jmp _endsw
			
		_InputError:
			invoke SetDlgItemText,hWnd,IDC_HEXRESULT,chr$("Invalid operands!")
			xor eax,eax
			ret
		_endsw:
		
		pushfd
		pop efldw
		
		mov ebx,eax
		push ebx
		push edx
		invoke SendDlgItemMessage,hWnd,IDC_REVBYTES,BM_GETCHECK,1,0
		test al,al
		jz _notrev
		bswap ebx
		_notrev:
		mov eax,operand_idc
		cmp eax,IDC_MUL
		jb _ndp
		cmp eax,IDC_IDIV
		ja _ndp
		pop edx
		invoke wsprintf,addr szHexResult,chr$("%08X:%08X"),edx,ebx
		jmp _decp
		_ndp:
		pop edx
		invoke wsprintf,addr szHexResult,chr$("%08X"),ebx
		_decp:
		pop ebx
		
		invoke SendDlgItemMessage,hWnd,IDC_SIGNEDINT,BM_GETCHECK,1,0
		and al,al
		movzx eax,al
		invoke SetDlgItemInt,hWnd,IDC_DECRESULT,ebx,eax
		
		mov esi,offset szBinResult
		mov edi,10
		xor ecx,ecx
		inc ecx
		_l2:
		mov eax,ecx
		inc eax
		xor edx,edx
		div edi
		test edx,edx
		jnz _ns
		mov byte ptr [esi],20h
		inc ecx
		jmp _inc
		_ns:
		shl ebx,1
		mov byte ptr [esi],'0'
		jnc _inc
		mov byte ptr [esi],'1'
		_inc:
		inc esi
		inc ecx
		cmp ecx,32+6
		jbe _l2
		mov byte ptr [esi],0
		
		invoke SetDlgItemText,hWnd,IDC_HEXRESULT,addr szHexResult
		invoke SetDlgItemText,hWnd,IDC_BINRESULT,addr szBinResult
		
		and efldw,0000100011010101b
		
		invoke wsprintf,addr szEFL,chr$("%08X"),efldw
		invoke SetDlgItemText,hWnd,IDC_EFL,addr szEFL
		
		test efldw,0000000000000001b
		jz _n1
		invoke GetDlgItem,hWnd,IDC_CFF
		invoke EnableWindow,eax,TRUE
		jmp _s1
		_n1:
		invoke GetDlgItem,hWnd,IDC_CFF
		invoke EnableWindow,eax,FALSE
		_s1:
		
		test efldw,0000000000000100b
		jz _n2
		invoke GetDlgItem,hWnd,IDC_PF
		invoke EnableWindow,eax,TRUE
		jmp _s2
		_n2:
		invoke GetDlgItem,hWnd,IDC_PF
		invoke EnableWindow,eax,FALSE
		_s2:		
			
		test efldw,0000000000010000b
		jz _n3
		invoke GetDlgItem,hWnd,IDC_AF
		invoke EnableWindow,eax,TRUE
		jmp _s3
		_n3:
		invoke GetDlgItem,hWnd,IDC_AF
		invoke EnableWindow,eax,FALSE
		_s3:		
		
		test efldw,0000000001000000b
		jz _n4
		invoke GetDlgItem,hWnd,IDC_ZF
		invoke EnableWindow,eax,TRUE
		jmp _s4
		_n4:
		invoke GetDlgItem,hWnd,IDC_ZF
		invoke EnableWindow,eax,FALSE
		_s4:	
				
		test efldw,0000000010000000b
		jz _n5
		invoke GetDlgItem,hWnd,IDC_SF
		invoke EnableWindow,eax,TRUE
		jmp _s5
		_n5:
		invoke GetDlgItem,hWnd,IDC_SF
		invoke EnableWindow,eax,FALSE
		_s5:	
		
		test efldw,0000100000000000b
		jz _n6
		invoke GetDlgItem,hWnd,IDC_OF
		invoke EnableWindow,eax,TRUE
		jmp _s6
		_n6:
		invoke GetDlgItem,hWnd,IDC_OF
		invoke EnableWindow,eax,FALSE
		_s6:		
		
		.endif
		
	.elseif eax == WM_CLOSE
		invoke EndDialog,hWnd,0
	.endif

	xor	eax,eax
	ret
DlgProc	endp

; by lingo (drizz stdlib)
HexToDw PROC pString:DWORD
	mov ecx,pString
	xor eax,eax
	mov [ebp+8],ebx ;save ebx register
	xor ebx,ebx
@@:	
	movzx edx,byte ptr[ecx]
	shl eax,4
	and ebx,0Fh
	add eax,ebx
	cmp edx,40h
	sbb ebx,ebx
	sub edx,37h
	and ebx,7
	inc ecx
	add ebx,edx
	jns @B
	mov ebx,[ebp+8]
	ret 1*4
HexToDw ENDP

end start
